
'=================================================
'=           MAX7456 Video overlay Demo          =
'=            By EvertDekker.com 2009            =
'= Created with Bascom-Avr: 1.11.9.3.001 license =
'=          No copyright for private use         =
'=                 Version 1.1                   =
'=================================================
'=                                               =
'=                             =
'=           SENY - 20.10.2012                   =
'=                                               =
'=================================================
$regfile = "m16def.DAT"
$crystal = 16000000
$baud = 19200
$hwstack = 150
$swstack = 150
$framesize = 100

Config Spi = Hard , Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 16 , Noss = 0       'Setup the hardware spi
Spiinit                                                     ' SPI

'=== Dimension ===
Dim Temp As Byte , Lus As Byte
Dim Regaddr As Byte
Dim Regdata As Byte
Dim Buffer(2) As Byte

Dim Temptextstring As String * 10

Declare Sub Initmax7456()
Declare Sub Videotext(byval Text As String , Byval Ypos As Byte , Byval Xpos As Byte)
Declare Sub Writereg(byval Regaddr As Byte , Byval Regdata As Byte)
Declare Sub Rowbrightness(byval Row As Byte , Byval Brightness As Byte)
Declare Sub Writecustomcharacter(byval Characters As Byte)

'=== Const ===
Const Vm0 = &H00                                            '  1
Const Vm1 = &H01                                            '  2
Const Hos = &H02                                            'Horizontal Offset
Const Vos = &H03                                            'Vertical Offset
Const Dmm = &H04                                            'Display Memory Mode
Const Dmah = &H05                                           'Display Memory Address High
Const Dmal = &H06                                           'Display Memory Address Low
Const Dmdi = &H07                                           'Display Memory Data In
Const Cmm = &H08                                            'Character Memory Mode
Const Cmah = &H09                                           'Character Memory Address High
Const Cmal = &H0A                                           'Character Memory Address Low
Const Cmdi = &H0B                                           'Character Memory Data In
Const Osdm = &H0C                                           'Osd Insertion Mux
Const Osdbl = &H6C                                          'OSD Black Level
Const Readreg = &H80                                        'Read register = register + &H80
Const Status_read = &HA0                                    'Status register
Const True = 1
Const False = 0

'=== Main ===
Initmax7456                                                 'Init the Max7456
Waitms 100

'Call Writecustomcharacter(64)      '    MAX7456 NVM,
Do



'Videotext " " , 1 , 2
Videotext " " , 2 , 7
Videotext " " , 3 , 10
Videotext "AVRPROJECT.RU" , 4 , 7
'Videotext "" , 5 , 2
'Videotext "" , 6 , 2
'Videotext "" , 7 , 2
'Videotext "" , 8 , 2
'Videotext "!#" , 9 , 2
'Videotext "$%" , 10 , 2
'Videotext "&*" , 11 , 2
'Videotext "" , 12 , 2
'Videotext "" , 13 , 2
'Videotext " " , 14 , 2

'Videotext Temptextstring , 7 , 2
'Rowbrightness 10 , &B00001111                               '  , . SUB   
' 27  14 
Wait 5
Loop
End

'=== Subroutines===
Sub Initmax7456()
Writereg Vm0 , &B01001100
Writereg Vm1 , &B01111111
Writereg Dmm , &B01000000
Writereg Hos , &B00011111
Writereg Vos , &B00010000
End Sub

Sub Videotext(byval Text As String , Byval Ypos As Byte , Byval Xpos As Byte)
Local Charcount As Byte , Tempstring As String * 1 , Tempbyte As Byte , Position As Word , Chars As Byte , Controlcharcount As Byte , Attribute As Byte
Controlcharcount = 0 : Attribute = 0                        '    
Charcount = Len(text) - 1                                   '     ,       0
For Chars = 0 To Charcount                                  '  ,     
 Position = Ypos * 30                                       ',       30 =   
 Position = Position + Xpos                                 'Position + the xpos
 Position = Position + Chars                                'Position +      
 Position = Position - Controlcharcount                     'There was a controle charater, deduct from the charactercount because it must not be handled as real character
 Regdata = High(position)                                   'Put the highbyte of position in the regdatabuffer
 Writereg Dmah , Regdata                                    '   
 Regdata = Low(position)                                    'Put the lowbyte of position in the regdatabuffer
 Writereg Dmal , Regdata                                    'Write the data to the register
  Tempbyte = Chars + 1                                      'Need the character position from the textstring
 Tempstring = Mid(text , Tempbyte , 1)                      'Take out 1 character that we need to handle now
 Tempbyte = Asc(tempstring)                                 'Get the ascii value of this character

  If Tempbyte <= 255 Then                                   '   130   
   Tempbyte = Tempbyte - 32                                 'Max7456 character table starts at &H00, so deduct 32 to get it even with the ascii table
   Regdata = Lookup(tempbyte , Characterslookup)            'Lookup the character from the datatable
   Writereg Dmdi , Regdata                                  'Write the data to the DisplayMemory register
  End If

   If Tempbyte = 1 Or Tempbyte = 3 Or Tempbyte = 4 Or Tempbyte = 5 Or Tempbyte = 6 Or Tempbyte = 10 Then
    Incr Controlcharcount                                   'It's a controle character, increase the counter

   If Tempbyte = 1 Then Set Attribute.7                     'Set the local background bit in the character attribute
   If Tempbyte = 3 Then Reset Attribute.7                   'Reset the local background bit
   If Tempbyte = 4 Then Set Attribute.6                     'Set the blink bit
   If Tempbyte = 5 Then Reset Attribute.6                   'Reset the blink bit
   If Tempbyte = 6 Then Set Attribute.5                     'Set the inverse bit
   If Tempbyte = 10 Then Reset Attribute.5
   End If

 Regdata = High(position)                                   'Put the highbyte of position in the regdatabuffer
 Regdata = Regdata Or &B00000010                            'Set bit1 for the character attribute
 Writereg Dmah , Regdata                                    'Write the data to the register
 Regdata = Low(position)                                    'Put the lowbyte of position in the regdatabuffer
 Writereg Dmal , Regdata                                    'Write the data to the register
 Writereg Dmdi , Attribute                                  'Write the attribute to the DisplayMemory register

Next Charcount                                              'Carcount
End Sub


Sub Writecustomcharacter(byval Characters As Byte)
 Local Count As Byte
   Restore Customcharacter                                  'Goto    data
 For Count = 1 To Characters                                ' ,    ,      data
  Writereg Vm0 , &B01000100                                 'Disable osd
  Read Regdata                                              'Read the first databyte, is the character to will be programmed
  Writereg Cmah , Regdata                                   'Write to the register
  For Lus = 0 To 53                                         'Each Character is made of 54bytes
       Writereg Cmal , Lus                                  'Write the byteno of the character
       Read Regdata                                         'Read the data from the datatable
       Writereg Cmdi , Regdata                              'program the data in the shadowram
  Next Lus
  Writereg Cmm , &HA0                                       'Copy shadowram to NVram
  Waitms 200                                                'Wait until copy is ready
 Next Count
  Writereg Vm0 , &B01001100                                 'enable osd
End Sub





Sub Rowbrightness(byval Row As Byte , Byval Brightness As Byte)
If Brightness > &B00001111 Then Brightness = &B00001111     'B0000xx11 Character Black Level in % of OSD white level 00 = 0% 01 = 10% 10 = 20% 11 = 30%
Regaddr = &H10 + Row                                        'B000011xx Character White Level  in % of OSD white level 00 = 120%  01 = 100%  10 = 90% 11 = 80%
Regdata = Brightness
Writereg Regaddr , Regdata
End Sub

Sub Writereg(byval Regaddr As Byte , Byval Regdata As Byte)
 Buffer(1) = Regaddr                                        '   
 Buffer(2) = Regdata
Spiout Buffer(1) , 2                                        '   SPI

End Sub

End

Characterslookup:
'Convert the ascii table to the Max7456 table. (Not excist) are characters that are not in the MAX7456 table and will show a ? (&H42)
Data &H00                                                   '32 Space
Data &H96                                                   '33 !  (not excist)
Data &H48                                                   '34 ""
Data &H99                                                   '35 # (not excist)
Data &H42                                                   '36 $ (not excist)
Data &H42                                                   '37 % (not excist)
Data &H42                                                   '38 & (not excist)
Data &H47                                                   '39 '
Data &H3F                                                   '40 (
Data &H40                                                   '41 )
Data &H42                                                   '42 * (not excist)
Data &H50                                                   '43 + (not excist)
Data &H45                                                   '44 ,
Data &H49                                                   '45 -
Data &H41                                                   '46 .
Data &H47                                                   '47 /
Data &H0A                                                   '48 0
Data &H01                                                   '49 1
Data &H02                                                   '50 2
Data &H03                                                   '51 3
Data &H04                                                   '52 4
Data &H05                                                   '53 5
Data &H06                                                   '54 6
Data &H07                                                   '55 7
Data &H08                                                   '56 8
Data &H09                                                   '57 9
Data &H44                                                   '58 :
Data &H43                                                   '59 ;
Data &H4A                                                   '60 <
Data &H42                                                   '61 = (not excist)
Data &H4B                                                   '62 >
Data &H42                                                   '63 ?
Data &H4C                                                   '64 @
Data &H0B                                                   '65 A
Data &H0C                                                   '66 B
Data &H0D                                                   '67 C
Data &H0E                                                   '68 D
Data &H0F                                                   '69 E
Data &H10                                                   '70 F
Data &H11                                                   '71 G
Data &H12                                                   '72 H
Data &H13                                                   '73 I
Data &H14                                                   '74 J
Data &H15                                                   '75 K
Data &H16                                                   '76 L
Data &H17                                                   '77 M
Data &H18                                                   '78 N
Data &H19                                                   '79 O
Data &H1A                                                   '80 P
Data &H1B                                                   '81 Q
Data &H1C                                                   '82 R
Data &H1D                                                   '83 S
Data &H1E                                                   '84 T
Data &H1F                                                   '85 U
Data &H20                                                   '86 V
Data &H21                                                   '87 W
Data &H22                                                   '88 X
Data &H23                                                   '89 Y
Data &H24                                                   '90 Z
Data &H42                                                   '91 [ (not excist)
Data &H42                                                   '92 \ (not excist)
Data &H42                                                   '93 ] (not excist)
Data &H42                                                   '94 ^ (not excist)
Data &H42                                                   '95 Underscore (not excist)
Data &H42                                                   '96 ` (not excist)
Data &H25                                                   '97 a
Data &H26                                                   '98 b
Data &H27                                                   '99 c
Data &H28                                                   '100 d
Data &H29                                                   '101 e
Data &H2A                                                   '102 f
Data &H2B                                                   '103 g
Data &H2C                                                   '104 h
Data &H2D                                                   '105 i
Data &H2E                                                   '106 j
Data &H2F                                                   '107 k
Data &H30                                                   '108 l
Data &H31                                                   '109 m
Data &H32                                                   '110 n
Data &H33                                                   '111 o
Data &H34                                                   '112 p
Data &H35                                                   '113 q
Data &H36                                                   '114 r
Data &H37                                                   '115 s
Data &H38                                                   '116 t
Data &H39                                                   '117 u
Data &H3A                                                   '118 v
Data &H3B                                                   '119 w
Data &H3C                                                   '120 x
Data &H3D                                                   '121 y
Data &H3E                                                   '122 z
Data &H42                                                   '123 {  (not excist)
Data &H42                                                   '124 |  (not excist)
Data &H42                                                   '125 }  (not excist)
Data &H42                                                   '126 ~  (not excist)
Data &H42                                                   '127 del( )
Data &H42                                                   '128
Data &H42                                                   '129
Data &H42                                                   '130                                                '130
Data &H42                                                   '131     (100)
Data &H42                                                   '132
Data &H42                                                   '133
Data &H42                                                   '134
Data &H42                                                   '135
Data &H42                                                   '136
Data &H42                                                   '137
Data &H42                                                   '138
Data &H42                                                   '139
Data &H42                                                   '140
Data &H42                                                   '141
Data &H42                                                   '142
Data &H42                                                   '143
Data &H42                                                   '144
Data &H42                                                   '145
Data &H42                                                   '146
Data &H42                                                   '147
Data &H42                                                   '148
Data &H42                                                   '149
Data &H42                                                   '150
Data &H42                                                   '151
Data &H42                                                   '152
Data &H42                                                   '153
Data &H42                                                   '154
Data &H42                                                   '155
Data &H42                                                   '156
Data &H42                                                   '157
Data &H42                                                   '158
Data &H42                                                   '159
Data &H42                                                   '160
Data &H42                                                   '161
Data &H42                                                   '162
Data &H42                                                   '163
Data &H42                                                   '164
Data &H42                                                   '165
Data &H42                                                   '166
Data &H42                                                   '167
Data &H42                                                   '168
Data &H42                                                   '169
Data &H42                                                   '170
Data &H42                                                   '171
Data &H42                                                   '172
Data &H42                                                   '173
Data &H42                                                   '174
Data &H42                                                   '175
Data &H42                                                   '176
Data &H42                                                   '177
Data &H42                                                   '178
Data &H42                                                   '179
Data &H42                                                   '180
Data &H42                                                   '181
Data &H42                                                   '182
Data &H42                                                   '183
Data &H42                                                   '184
Data &H42                                                   '185
Data &H42                                                   '186
Data &H42                                                   '187
Data &H42                                                   '188
Data &H42                                                   '189
Data &H42                                                   '190
Data &H42                                                   '191
Data &H50                                                   '160    (192)
Data &H51                                                   ' 161 
Data &H52                                                   ' 130 
Data &H53                                                   '131 
Data &H54                                                   '132 
Data &H55                                                   '133 
Data &H56                                                   '134 
Data &H57                                                   '135 
Data &H58                                                   '136 
Data &H59                                                   '137 
Data &H5A                                                   '138 ()
Data &H5B                                                   '139 
Data &H5C                                                   '140  ()
Data &H5D                                                   '141  ()
Data &H5E                                                   '142 O (E)
Data &H5F                                                   '143 
Data &H60                                                   '144  ()
Data &H61                                                   '145  ()
Data &H62                                                   '146  ()
Data &H63                                                   '147 
Data &H64                                                   '148 
Data &H65                                                   '149 
Data &H66                                                   '150 
Data &H67                                                   '151 
Data &H68                                                   '152 
Data &H69                                                   '153 
Data &H6A                                                   '154 
Data &H6B                                                   '155 
Data &H6C                                                   '156 
Data &H6D                                                   '157 
Data &H6E                                                   '158 
Data &H6F                                                   '159 
Data &H70                                                   '160 a ()
Data &H71                                                   '161 
Data &H72                                                   '162 
Data &H73                                                   '163 
Data &H74                                                   '164 
Data &H75                                                   '165 e
Data &H76                                                   '166 
Data &H77                                                   '167 
Data &H78                                                   '168 
Data &H79                                                   '169 
Data &H7A                                                   '170 
Data &H7B                                                   '171 
Data &H7C                                                   '172 
Data &H7D                                                   '173 
Data &H7E                                                   '174 
Data &H7F                                                   '175 
Data &H80                                                   '224 
Data &H81                                                   '225 
Data &H82                                                   '226 
Data &H83                                                   '227 
Data &H84                                                   '180 
Data &H85                                                   '181 
Data &H86                                                   '182 
Data &H87                                                   '183 
Data &H88                                                   '184 
Data &H89                                                   '185 
Data &H8A                                                   '186 
Data &H8B                                                   '187 
Data &H8C                                                   '188 
Data &H8D                                                   '189 
Data &H8E                                                   '190 
Data &H8F                                                   '191 
                     '


Customcharacter:                                            '   

'$include "rus.bas"




